/* $Id: BindPreparedStatement.java,v 1.2 2004/08/24 11:41:29 yuk Exp $
 * create: 2004/08/24
 * (c)2004 Lavans Networks Inc. All Rights Reserved.
 */
package com.lavans.util.jdbc;

import java.io.InputStream;
import java.io.Reader;
import java.math.BigDecimal;
import java.net.URL;
import java.sql.Array;
import java.sql.Blob;
import java.sql.Clob;
import java.sql.Connection;
import java.sql.Date;
import java.sql.ParameterMetaData;
import java.sql.PreparedStatement;
import java.sql.Ref;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.SQLWarning;
import java.sql.Time;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.StringTokenizer;

import com.lavans.util.Logger;
import com.lavans.util.Method;

/**
 * @author dobashi
 * @version 1.00
 */
public class BindPreparedStatement implements PreparedStatement {
	static{
		// Logger/StatisticsŖ{NX̖OoȂ悤
		// XgɒǉB
		Method.addIgnore(BindPreparedStatement.class.getName());
	}
	/** ڏB */
	private PreparedStatement st=null;

	/** NXBgтgetName()ƒxȂ̂łŒ`ĂB */
	//private static final String CLASSNAME=LoggedPreparedStatement.class.getName();

	/** 
	 * ۂɔsSQLB
	 * ":param""?֕ϊς݁B
	 */
	private String sql = null;
	
	/**
	 * p[^ƁuԖڂ̃p[^vێMapB
	 * ̃p[^ŕ̃p[^\ꍇ̂ŁA
	 * valueIntegerListƂB
	 * z񂪉ϒȂ̂ŁAint[]^ł͔z񐔐̎Ȃ΂ȂȂB
	 */
	private Map paramMap = null;

	/**
	 * RXgN^B
	 * @param st
	 */
	public BindPreparedStatement(Connection con, String sql) throws SQLException{
		Logger logger = Logger.getInstance();
		logger.entering();
		logger.debug(sql);
		
		paramMap = new HashMap();
		
		/**
		 * :param?ɕϊB
		 * SQL"SELECT NAME FROM A WHERE ID=:id AND CLS=:cls"ȂAȉ̂悤ɂȂB
		 * 1.ŏtoken.nextToken()"SELECT NAME FROM A WHERE ID="܂Ŏ擾B
		 * 2.tolen.nextToken()"id AND CLS="擾B
		 * 3.endToken.nextToken()"id"擾ł̂ŁAp[^̒2łB
		 * 4.buf"?"𑫂āAnextStr瓪2bufɒǉB
		 */
		StringTokenizer token = new StringTokenizer(sql,":");
		int tokenCount = token.countTokens();		// rŃf~^ύX̂ŁAŃJEgĂ
		StringBuffer buf = new StringBuffer(sql.length());
		buf.append(token.nextToken());		// ŏ":"܂ł擾
		for(int i=1; i<tokenCount; i++){
//logger.debug("["+i+"]"+  	buf.toString());			
			String param = token.nextToken(", \t\r\n").substring(1);
			List paramNums = (List)paramMap.get(param);		// p[^ԍ̎o
			if(paramNums==null){							// ݂ȂȂ(oparamȂ)
				paramNums = new ArrayList(2);				// i[pList쐬
				paramMap.put(param,paramNums);				// Mapɓo^ĂB
			}
			paramNums.add(new Integer(i));
			
			String nextStr = "";
			try{
				nextStr = token.nextToken(":");
			}catch (Exception e) {
				// ̍Ō܂ŗĂƂException邪Ă悢B
			}
			buf.append("?"+ nextStr);
		}
		this.sql = buf.toString();
		this.st  = con.prepareStatement(this.sql);

		logger.debug(this.sql);
		logger.exiting();
	}

	/**
	 * p[^ł̐ݒ(String)B
	 * @param key
	 * @param x
	 * @throws SQLException
	 */
	public void setString(String key, String x) throws SQLException{
		List paramNums = (List)paramMap.get(key);
		if(paramNums==null){
			throw new SQLException("No such key ["+ key +"]");
		}
		for(int i=0; i<paramNums.size(); i++){
			Integer num = (Integer)paramNums.get(i);
			st.setString(num.intValue(),x);
		}
	}

	/**
	 * p[^ł̐ݒ(int)B
	 * @param key
	 * @param x
	 * @throws SQLException
	 */
	public void setInt(String key, int x) throws SQLException{
		List paramNums = (List)paramMap.get(key);
		if(paramNums==null){
			throw new SQLException("No such key ["+ key +"]");
		}
		for(int i=0; i<paramNums.size(); i++){
			Integer num = (Integer)paramNums.get(i);
			st.setInt(num.intValue(),x);
		}
	}

	/**
	 * p[^ł̐ݒ(byte)B
	 * @param key
	 * @param x
	 * @throws SQLException
	 */
	public void setByte(String key, byte x) throws SQLException{
		List paramNums = (List)paramMap.get(key);
		if(paramNums==null){
			throw new SQLException("No such key ["+ key +"]");
		}
		for(int i=0; i<paramNums.size(); i++){
			Integer num = (Integer)paramNums.get(i);
			st.setByte(num.intValue(),x);
		}
	}

	/**
	 * p[^ł̐ݒ(float)B
	 * @param key
	 * @param x
	 * @throws SQLException
	 */
	public void setFloat(String key, float x) throws SQLException{
		List paramNums = (List)paramMap.get(key);
		if(paramNums==null){
			throw new SQLException("No such key ["+ key +"]");
		}
		for(int i=0; i<paramNums.size(); i++){
			Integer num = (Integer)paramNums.get(i);
			st.setFloat(num.intValue(),x);
		}
	}

	/**
	 * p[^ł̐ݒ(double)B
	 * @param key
	 * @param x
	 * @throws SQLException
	 */
	public void setDouble(String key, double x) throws SQLException{
		List paramNums = (List)paramMap.get(key);
		if(paramNums==null){
			throw new SQLException("No such key ["+ key +"]");
		}
		for(int i=0; i<paramNums.size(); i++){
			Integer num = (Integer)paramNums.get(i);
			st.setDouble(num.intValue(),x);
		}
	}

	/**
	 * p[^ł̐ݒ(null)B
	 * @param key
	 * @param sqlType
	 * @throws SQLException
	 */
	public void setNull(String key, int sqlType) throws SQLException{
		List paramNums = (List)paramMap.get(key);
		if(paramNums==null){
			throw new SQLException("No such key ["+ key +"]");
		}
		for(int i=0; i<paramNums.size(); i++){
			Integer num = (Integer)paramNums.get(i);
			st.setNull(num.intValue(),sqlType);
		}
	}

	/**
	 * p[^ł̐ݒ(long)B
	 * @param key
	 * @param x
	 * @throws SQLException
	 */
	public void setLong(String key, long x) throws SQLException{
		List paramNums = (List)paramMap.get(key);
		if(paramNums==null){
			throw new SQLException("No such key ["+ key +"]");
		}
		for(int i=0; i<paramNums.size(); i++){
			Integer num = (Integer)paramNums.get(i);
			st.setLong(num.intValue(),x);
		}
	}

	/**
	 * p[^ł̐ݒ(short)B
	 * @param key
	 * @param x
	 * @throws SQLException
	 */
	public void setShort(String key, short x) throws SQLException{
		List paramNums = (List)paramMap.get(key);
		if(paramNums==null){
			throw new SQLException("No such key ["+ key +"]");
		}
		for(int i=0; i<paramNums.size(); i++){
			Integer num = (Integer)paramNums.get(i);
			st.setShort(num.intValue(),x);
		}
	}

	/**
	 * p[^ł̐ݒ(boolean)B
	 * @param key
	 * @param x
	 * @throws SQLException
	 */
	public void setBoolean(String key, boolean x) throws SQLException{
		List paramNums = (List)paramMap.get(key);
		if(paramNums==null){
			throw new SQLException("No such key ["+ key +"]");
		}
		for(int i=0; i<paramNums.size(); i++){
			Integer num = (Integer)paramNums.get(i);
			st.setBoolean(num.intValue(),x);
		}
	}

	/**
	 * p[^ł̐ݒ(byte[])B
	 * @param key
	 * @param x
	 * @throws SQLException
	 */
	public void setBytes(String key, byte[] x) throws SQLException{
		List paramNums = (List)paramMap.get(key);
		if(paramNums==null){
			throw new SQLException("No such key ["+ key +"]");
		}
		for(int i=0; i<paramNums.size(); i++){
			Integer num = (Integer)paramNums.get(i);
			st.setBytes(num.intValue(),x);
		}
	}

	/**
	 * p[^ł̐ݒ(java.sql.Date)B
	 * @param key
	 * @param x
	 * @throws SQLException
	 */
	public void setDate(String key, Date x) throws SQLException{
		List paramNums = (List)paramMap.get(key);
		if(paramNums==null){
			throw new SQLException("No such key ["+ key +"]");
		}
		for(int i=0; i<paramNums.size(); i++){
			Integer num = (Integer)paramNums.get(i);
			st.setDate(num.intValue(),x);
		}
	}

	/**
	 * p[^ł̐ݒ(java.sql.Time)B
	 * @param key
	 * @param x
	 * @throws SQLException
	 */
	public void setTime(String key, Time x) throws SQLException{
		List paramNums = (List)paramMap.get(key);
		if(paramNums==null){
			throw new SQLException("No such key ["+ key +"]");
		}
		for(int i=0; i<paramNums.size(); i++){
			Integer num = (Integer)paramNums.get(i);
			st.setTime(num.intValue(),x);
		}
	}

	/**
	 * p[^ł̐ݒ(java.sql.Timestamp)B
	 * @param key
	 * @param x
	 * @throws SQLException
	 */
	public void setTimestamp(String key, Timestamp x) throws SQLException{
		List paramNums = (List)paramMap.get(key);
		if(paramNums==null){
			throw new SQLException("No such key ["+ key +"]");
		}
		for(int i=0; i<paramNums.size(); i++){
			Integer num = (Integer)paramNums.get(i);
			st.setTimestamp(num.intValue(),x);
		}
	}

	/*
	 * ------------------------------------------------------
	 * PreaparedStatement
	 * ------------------------------------------------------
	 */

	/* ( Javadoc)
	 * @see java.sql.PreparedStatement#executeQuery()
	 */
	public ResultSet executeQuery() throws SQLException {
		ResultSet result = st.executeQuery();
		return result;
	}

	/* ( Javadoc)
	 * @see java.sql.PreparedStatement#executeUpdate()
	 */
	public int executeUpdate() throws SQLException {
		int result = st.executeUpdate();
		return result;
	}

	/* ( Javadoc)
	 * @see java.sql.PreparedStatement#execute()
	 */
	public boolean execute() throws SQLException {
		boolean result = st.execute();
		return result;
	}








	/* ( Javadoc)
	 * @see java.sql.PreparedStatement#addBatch()
	 */
	public void addBatch() throws SQLException {
		st.addBatch();

	}

	/* ( Javadoc)
	 * @see java.sql.PreparedStatement#clearParameters()
	 */
	public void clearParameters() throws SQLException {
		st.clearParameters();

	}


	/* ( Javadoc)
	 * @see java.sql.PreparedStatement#setByte(int, byte)
	 */
	public void setByte(int parameterIndex, byte x) throws SQLException {
		st.setByte(parameterIndex,x);
	}

	/* ( Javadoc)
	 * @see java.sql.PreparedStatement#setDouble(int, double)
	 */
	public void setDouble(int parameterIndex, double x) throws SQLException {
		st.setDouble(parameterIndex,x);
	}

	/* ( Javadoc)
	 * @see java.sql.PreparedStatement#setFloat(int, float)
	 */
	public void setFloat(int parameterIndex, float x) throws SQLException {
		st.setFloat(parameterIndex,x);
	}

	/* ( Javadoc)
	 * @see java.sql.PreparedStatement#setInt(int, int)
	 */
	public void setInt(int parameterIndex, int x) throws SQLException {
		st.setInt(parameterIndex,x);
	}

	/* ( Javadoc)
	 * @see java.sql.PreparedStatement#setNull(int, int)
	 */
	public void setNull(int parameterIndex, int sqlType) throws SQLException {
		st.setNull(parameterIndex,sqlType);
	}

	/* ( Javadoc)
	 * @see java.sql.PreparedStatement#setLong(int, long)
	 */
	public void setLong(int parameterIndex, long x) throws SQLException {
		st.setLong(parameterIndex,x);
	}

	/* ( Javadoc)
	 * @see java.sql.PreparedStatement#setShort(int, short)
	 */
	public void setShort(int parameterIndex, short x) throws SQLException {
		st.setShort(parameterIndex,x);
	}

	/* ( Javadoc)
	 * @see java.sql.PreparedStatement#setBoolean(int, boolean)
	 */
	public void setBoolean(int parameterIndex, boolean x) throws SQLException {
		st.setBoolean(parameterIndex,x);
	}

	/* ( Javadoc)
	 * @see java.sql.PreparedStatement#setBytes(int, byte[])
	 */
	public void setBytes(int parameterIndex, byte[] x) throws SQLException {
		st.setBytes(parameterIndex,x);
	}



	/* ( Javadoc)
	 * @see java.sql.PreparedStatement#setAsciiStream(int, java.io.InputStream, int)
	 */
	public void setAsciiStream(int parameterIndex, InputStream x, int length)
		throws SQLException {
		st.setAsciiStream(parameterIndex,x,length);
	}

	/* ( Javadoc)
	 * @see java.sql.PreparedStatement#setBinaryStream(int, java.io.InputStream, int)
	 */
	public void setBinaryStream(int parameterIndex, InputStream x, int length)
		throws SQLException {
		st.setBinaryStream(parameterIndex,x,length);
	}

	/**
	 * @see java.sql.PreparedStatement#setUnicodeStream(int, java.io.InputStream, int)
	 * @deprecated
	 */
	public  void setUnicodeStream(int parameterIndex, InputStream x, int length)
		throws SQLException {
		st.setUnicodeStream(parameterIndex,x,length);
	}

	/* ( Javadoc)
	 * @see java.sql.PreparedStatement#setCharacterStream(int, java.io.Reader, int)
	 */
	public void setCharacterStream(
		int parameterIndex,
		Reader reader,
		int length)
		throws SQLException {
		st.setCharacterStream(parameterIndex,reader,length);
	}

	/* ( Javadoc)
	 * @see java.sql.PreparedStatement#setObject(int, java.lang.Object)
	 */
	public void setObject(int parameterIndex, Object x) throws SQLException {
		st.setObject(parameterIndex,x);

	}

	/* ( Javadoc)
	 * @see java.sql.PreparedStatement#setObject(int, java.lang.Object, int)
	 */
	public void setObject(int parameterIndex, Object x, int targetSqlType)
		throws SQLException {
		st.setObject(parameterIndex,x,targetSqlType);
	}

	/* ( Javadoc)
	 * @see java.sql.PreparedStatement#setObject(int, java.lang.Object, int, int)
	 */
	public void setObject(
		int parameterIndex,
		Object x,
		int targetSqlType,
		int scale)
		throws SQLException {
		st.setObject(parameterIndex,x,targetSqlType,scale);
	}

	/* ( Javadoc)
	 * @see java.sql.PreparedStatement#setNull(int, int, java.lang.String)
	 */
	public void setNull(int paramIndex, int sqlType, String typeName)
		throws SQLException {
		st.setNull(paramIndex,sqlType,typeName);
	}

	/* ( Javadoc)
	 * @see java.sql.PreparedStatement#setString(int, java.lang.String)
	 */
	public void setString(int parameterIndex, String x) throws SQLException {
		st.setString(parameterIndex,x);
	}

	/* ( Javadoc)
	 * @see java.sql.PreparedStatement#setBigDecimal(int, java.math.BigDecimal)
	 */
	public void setBigDecimal(int parameterIndex, BigDecimal x)
		throws SQLException {
		setBigDecimal(parameterIndex,x);
	}


	/* ( Javadoc)
	 * @see java.sql.PreparedStatement#setURL(int, java.net.URL)
	 */
	public void setURL(int parameterIndex, URL x) throws SQLException {
		setURL(parameterIndex,x);
	}

	/* ( Javadoc)
	 * @see java.sql.PreparedStatement#setArray(int, java.sql.Array)
	 */
	public void setArray(int i, Array x) throws SQLException {
		setArray(i,x);
	}

	/* ( Javadoc)
	 * @see java.sql.PreparedStatement#setBlob(int, java.sql.Blob)
	 */
	public void setBlob(int i, Blob x) throws SQLException {
		setBlob(i,x);
	}

	/* ( Javadoc)
	 * @see java.sql.PreparedStatement#setClob(int, java.sql.Clob)
	 */
	public void setClob(int i, Clob x) throws SQLException {
		setClob(i,x);
	}

	/* ( Javadoc)
	 * @see java.sql.PreparedStatement#setDate(int, java.sql.Date)
	 */
	public void setDate(int parameterIndex, Date x) throws SQLException {
		setDate(parameterIndex,x);

	}


	/* ( Javadoc)
	 * @see java.sql.PreparedStatement#getParameterMetaData()
	 */
	public ParameterMetaData getParameterMetaData() throws SQLException {
		return st.getParameterMetaData();
	}

	/* ( Javadoc)
	 * @see java.sql.PreparedStatement#setRef(int, java.sql.Ref)
	 */
	public void setRef(int i, Ref x) throws SQLException {
		st.setRef(i,x);
	}


	/* ( Javadoc)
	 * @see java.sql.PreparedStatement#getMetaData()
	 */
	public ResultSetMetaData getMetaData() throws SQLException {
		return st.getMetaData();
	}

	/* ( Javadoc)
	 * @see java.sql.PreparedStatement#setTime(int, java.sql.Time)
	 */
	public void setTime(int parameterIndex, Time x) throws SQLException {
		st.setTime(parameterIndex,x);
	}

	/* ( Javadoc)
	 * @see java.sql.PreparedStatement#setTimestamp(int, java.sql.Timestamp)
	 */
	public void setTimestamp(int parameterIndex, Timestamp x)
		throws SQLException {
		st.setTimestamp(parameterIndex,x);
	}

	/* ( Javadoc)
	 * @see java.sql.PreparedStatement#setDate(int, java.sql.Date, java.util.Calendar)
	 */
	public void setDate(int parameterIndex, Date x, Calendar cal)
		throws SQLException {
		st.setDate(parameterIndex,x);
	}

	/* ( Javadoc)
	 * @see java.sql.PreparedStatement#setTime(int, java.sql.Time, java.util.Calendar)
	 */
	public void setTime(int parameterIndex, Time x, Calendar cal)
		throws SQLException {
		st.setTime(parameterIndex,x,cal);
	}

	/* ( Javadoc)
	 * @see java.sql.PreparedStatement#setTimestamp(int, java.sql.Timestamp, java.util.Calendar)
	 */
	public void setTimestamp(int parameterIndex, Timestamp x, Calendar cal)
		throws SQLException {
		st.setTimestamp(parameterIndex,x,cal);
	}

	/*
	 * ------------------------------------------------------
	 * Statement
	 * ------------------------------------------------------
	 */
	/**
	 * @see java.sql.Statement#executeQuery(java.lang.String)
	 */
	public ResultSet executeQuery(String sql) throws SQLException {
		return st.executeQuery(sql);
	}

	/**
	 * @see java.sql.Statement#executeUpdate(java.lang.String)
	 */
	public int executeUpdate(String sql) throws SQLException {
		return st.executeUpdate(sql);
	}


	/**
	 * @see java.sql.Statement#executeUpdate(java.lang.String, int)
	 */
	public int executeUpdate(String sql, int autoGeneratedKeys)
		throws SQLException {
		return st.executeUpdate(sql,autoGeneratedKeys);
	}

	/**
	 * @see java.sql.Statement#executeUpdate(java.lang.String, int[])
	 */
	public int executeUpdate(String sql, int[] columnIndexes)
		throws SQLException {
		return st.executeUpdate(sql,columnIndexes);
	}

	/**
	 * @see java.sql.Statement#executeUpdate(java.lang.String, java.lang.String[])
	 */
	public int executeUpdate(String sql, String[] columnNames)
		throws SQLException {
		return st.executeUpdate(sql,columnNames);
	}

	/**
	 * @see java.sql.Statement#execute(java.lang.String, int)
	 */
	public boolean execute(String sql, int autoGeneratedKeys)
		throws SQLException {
		return st.execute(sql,autoGeneratedKeys);
	}

	/**
	 * @see java.sql.Statement#execute(java.lang.String)
	 */
	public boolean execute(String sql) throws SQLException {
		return st.execute(sql);
	}

	/**
	 * @see java.sql.Statement#execute(java.lang.String, int[])
	 */
	public boolean execute(String sql, int[] columnIndexes)
		throws SQLException {
		return st.execute(sql,columnIndexes);
	}

	/**
	 * @see java.sql.Statement#execute(java.lang.String, java.lang.String[])
	 */
	public boolean execute(String sql, String[] columnNames)
		throws SQLException {
		return st.execute(sql,columnNames);
	}





	/* ( Javadoc)
	 * @see java.sql.Statement#getFetchDirection()
	 */
	public int getFetchDirection() throws SQLException {
		return st.getFetchDirection();
	}

	/* ( Javadoc)
	 * @see java.sql.Statement#getFetchSize()
	 */
	public int getFetchSize() throws SQLException {
		return st.getFetchSize();
	}

	/* ( Javadoc)
	 * @see java.sql.Statement#getMaxFieldSize()
	 */
	public int getMaxFieldSize() throws SQLException {
		return st.getMaxFieldSize();
	}

	/* ( Javadoc)
	 * @see java.sql.Statement#getMaxRows()
	 */
	public int getMaxRows() throws SQLException {
		return st.getMaxRows();
	}

	/* ( Javadoc)
	 * @see java.sql.Statement#getQueryTimeout()
	 */
	public int getQueryTimeout() throws SQLException {
		return st.getQueryTimeout();
	}

	/* ( Javadoc)
	 * @see java.sql.Statement#getResultSetConcurrency()
	 */
	public int getResultSetConcurrency() throws SQLException {
		return st.getResultSetConcurrency();
	}

	/* ( Javadoc)
	 * @see java.sql.Statement#getResultSetHoldability()
	 */
	public int getResultSetHoldability() throws SQLException {
		return st.getResultSetHoldability();
	}

	/* ( Javadoc)
	 * @see java.sql.Statement#getResultSetType()
	 */
	public int getResultSetType() throws SQLException {
		return st.getResultSetType();
	}

	/* ( Javadoc)
	 * @see java.sql.Statement#getUpdateCount()
	 */
	public int getUpdateCount() throws SQLException {
		return st.getUpdateCount();
	}

	/* ( Javadoc)
	 * @see java.sql.Statement#cancel()
	 */
	public void cancel() throws SQLException {
		st.cancel();
	}

	/* ( Javadoc)
	 * @see java.sql.Statement#clearBatch()
	 */
	public void clearBatch() throws SQLException {
		st.clearBatch();
	}

	/* ( Javadoc)
	 * @see java.sql.Statement#clearWarnings()
	 */
	public void clearWarnings() throws SQLException {
		st.clearWarnings();
	}

	/* ( Javadoc)
	 * @see java.sql.Statement#close()
	 */
	public void close() throws SQLException {
		st.close();
	}

	/* ( Javadoc)
	 * @see java.sql.Statement#getMoreResults()
	 */
	public boolean getMoreResults() throws SQLException {
		return st.getMoreResults();
	}

	/* ( Javadoc)
	 * @see java.sql.Statement#executeBatch()
	 */
	public int[] executeBatch() throws SQLException {
		return st.executeBatch();
	}

	/* ( Javadoc)
	 * @see java.sql.Statement#setFetchDirection(int)
	 */
	public void setFetchDirection(int direction) throws SQLException {
		st.setFetchDirection(direction);
	}

	/* ( Javadoc)
	 * @see java.sql.Statement#setFetchSize(int)
	 */
	public void setFetchSize(int rows) throws SQLException {
		st.setFetchSize(rows);
	}

	/* ( Javadoc)
	 * @see java.sql.Statement#setMaxFieldSize(int)
	 */
	public void setMaxFieldSize(int max) throws SQLException {
		st.setMaxFieldSize(max);
	}

	/* ( Javadoc)
	 * @see java.sql.Statement#setMaxRows(int)
	 */
	public void setMaxRows(int max) throws SQLException {
		st.setMaxRows(max);
	}

	/* ( Javadoc)
	 * @see java.sql.Statement#setQueryTimeout(int)
	 */
	public void setQueryTimeout(int seconds) throws SQLException {
		st.setQueryTimeout(seconds);
	}

	/* ( Javadoc)
	 * @see java.sql.Statement#getMoreResults(int)
	 */
	public boolean getMoreResults(int current) throws SQLException {
		return st.getMoreResults(current);
	}

	/* ( Javadoc)
	 * @see java.sql.Statement#setEscapeProcessing(boolean)
	 */
	public void setEscapeProcessing(boolean enable) throws SQLException {
		st.setEscapeProcessing(enable);
	}


	/* ( Javadoc)
	 * @see java.sql.Statement#addBatch(java.lang.String)
	 */
	public void addBatch(String sql) throws SQLException {
		st.addBatch(sql);
	}

	/* ( Javadoc)
	 * @see java.sql.Statement#setCursorName(java.lang.String)
	 */
	public void setCursorName(String name) throws SQLException {
		st.setCursorName(name);
	}


	/* ( Javadoc)
	 * @see java.sql.Statement#getConnection()
	 */
	public Connection getConnection() throws SQLException {
		return st.getConnection();
	}

	/* ( Javadoc)
	 * @see java.sql.Statement#getGeneratedKeys()
	 */
	public ResultSet getGeneratedKeys() throws SQLException {
		return st.getGeneratedKeys();
	}

	/* ( Javadoc)
	 * @see java.sql.Statement#getResultSet()
	 */
	public ResultSet getResultSet() throws SQLException {
		return st.getResultSet();
	}

	/* ( Javadoc)
	 * @see java.sql.Statement#getWarnings()
	 */
	public SQLWarning getWarnings() throws SQLException {
		return st.getWarnings();
	}
}
