/**
 * $Id: DBManager.java,v 1.3 2004/08/24 11:41:29 yuk Exp $
 *
 * Copyright Lavans Networks Inc.
 */
package com.lavans.util.jdbc;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import com.lavans.util.Config;
import com.lavans.util.Logger;
import com.lavans.util.Method;

/**
 * DBManager.
 *
 * @author	dobashi
 * @version	1.0
 */
public class DBManager
{
	/**
	 * Logger
	 */
	private static Logger logger = null;

//	private static final String CLASSNAME="com.lavans.util.jdbc.DBManager";
	private static final String CLASSNAME=DBManager.class.getName();
	/**
	 * ݒt@C̃ZNVB
	 */
	private static final String CONFIG_SECTION="database";
	
	/**
	 * SQLvWAڑ󋵊Ď邩B
	 */
	private static boolean statistics = false;
	
	/**
	 * ڑ󋵕ۊǗpMapB
	 */
	private static Map countConnMap = null;

	/**
	 * DatabaseꗗBConnectionPoolۑzB
	 */
	private static Map  dbMap = null;
	
	/**
	 * ڑJEgpz̒`B
	 * count[COUNT_GET]Ɏ擾񐔂Acount[COUNT_RELEASE]ɕԋp񐔂B
	 */
	private static final int COUNT_GET=0;
	private static final int COUNT_RELEASE=1;

	// 
	static{
		init();
	}
	
	/**
	 * B
	 *
	 */
	private static void init(){
		logger = Logger.getInstance();

		// databaseZNV̎擾 ----------------------------
		dbMap = new HashMap();
		Element conf = (Element)Config.getNode(CONFIG_SECTION);
		NodeList nodeList = conf.getChildNodes();
		if(nodeList==null){	// ݒt@Cdatabasew肪ꍇ
			return;			// ȂɂȂB
		}
		
		// vAڑǗ ----------------------------------
		try{
			statistics = Boolean.valueOf(conf.getAttribute("statistics")).booleanValue();
		}catch (Exception e) {
			// sfalsê܂
		}
		countConnMap = new HashMap();
		
		String name=null,driver=null,url=null,user=null,pass=null,valid_sql=null,max=null,init=null;
		for(int i=0; i<nodeList.getLength(); i++){

			if((nodeList.item(i).getNodeType()==Node.TEXT_NODE) ||
			   (nodeList.item(i).getNodeType()==Node.COMMENT_NODE) ){
				continue;
			}
			Element dbConf = (Element)nodeList.item(i);
			
			name   = dbConf.getNodeName();
			driver = dbConf.getAttribute("driver");
			url    = dbConf.getAttribute("url");
			user   = dbConf.getAttribute("user");
			pass   = dbConf.getAttribute("pass");
			max    = dbConf.getAttribute("max_connections");
			init   = dbConf.getAttribute("init_connections");
			logger.debug("max:"+max+", init:"+init);
			ConnectionPool pool = new ConnectionPool(driver,url,user,pass);

			// őڑ			
			try{
				pool.setMaxConnections(Integer.parseInt(max));
			}catch(NumberFormatException e){}
			// ڑ
			try{
				pool.setInitConnections(Integer.parseInt(init));
			}catch(NumberFormatException e){}
			// SQLv
			pool.setStatistics(statistics);
			
			// Jn
			try{
				pool.init();
			}catch(Exception e){
				logger.err(e);
			}
			dbMap.put(name,pool);
			logger.debug("create ConnectionPool["+name+"]");
		}
	}
	

	/**
	 * DBւ̃RlNV擾
	 */
	public static BindConnection getConnection()
	  throws SQLException
	{
		return getConnection("default");
	}
	/**
	 * DBւ̃RlNV擾
	 */
	public static BindConnection getConnection(String dbName)
	  throws SQLException				// O͌Ăяo֊ۓ
	{
//		logger.entering();
		ConnectionPool pool = (ConnectionPool)dbMap.get(dbName);

		// ڑԊǗꍇ ----------------
		if(statistics){
			String method = Method.getMethodName(CLASSNAME);
			int[] count = (int[])countConnMap.get(method);
			if(count==null){
				count = new int[2];
				count[COUNT_GET]=1;
				count[COUNT_RELEASE]=0;
				countConnMap.put(method,count);
			}else{
				count[COUNT_GET]++;
			}
		}

//		logger.debug(logger.getMethodName("jp.co.lavans.util.DBManager"));
//		logger.exiting();
		return pool.getConnection();
	}

	/**
	 * DBւ̃RlNVԋp
	 */
	public static void releaseConnection(Connection conn)
	  throws SQLException				// O͌Ăяo֊ۓ
	{
		releaseConnection(conn,"default");
	}
	
	/**
	 * DBւ̃RlNVԋp
	 */
	public static void releaseConnection(Connection conn,String dbName)
	  throws SQLException				// O͌Ăяo֊ۓ
	{
		ConnectionPool pool = (ConnectionPool)dbMap.get(dbName);
		pool.releaseConnection(conn);

		// ڑԊǗꍇ ----------------
		if(statistics){
			String method = Method.getMethodName(CLASSNAME);
			int[] count = (int[])countConnMap.get(method);
			if(count==null){
				logger.debug("݂oĂȂ\bhԋpꂽB");
				count[COUNT_GET]=0;
				count[COUNT_RELEASE]=1;
				countConnMap.put(method,count);
			}else{
				count[COUNT_RELEASE]++;
			}

//			logger.debug(viewConnectionPool());
		}
	}

	/**
	 * RlNVݏo󋵁B
	 * RlNV݂oꗗ\B
	 * 
	 * @return String 
	 */
	public static String viewConnectionPool(){
		if(!statistics){
			return "";
		}
		
		Collection col = countConnMap.keySet();
		List list = new ArrayList(col.size());
		for(Iterator ite=col.iterator(); ite.hasNext();){
			list.add(ite.next());
		}
		Collections.sort(list);
		
		StringBuffer buf = new StringBuffer();
		buf.append("Connection List\n");
		for(int i=0; i<list.size(); i++){
			int[] count = (int[])countConnMap.get(list.get(i));
			buf.append(
			  list.get(i)
			  +"\t:"+ count[COUNT_GET]
			  +"\t:"+ count[COUNT_RELEASE]
			  +"\t:"+ (count[COUNT_GET]-count[COUNT_RELEASE]) +"\n");
		}
		return buf.toString();
	}
}
		